# std::optional::emplace

From cppreference.com
< cpp‎ | utility‎ | optional

template< class... Args > T& emplace( Args&&... args ); |  | (since C++17)
template< class U, class... Args > T& emplace( std::initializer_list<U> ilist, Args&&... args ); |  | (since C++17)

Constructs the contained value in-place. If *this already contains a value before the call, the contained value is destroyed by calling its destructor.

1) Initializes the contained value by direct-initializing (but not direct-list-initializing) with std::forward<Args>(args)... as parameters.
2) Initializes the contained value by calling its constructor with ilist, std::forward<Args>(args)... as parameters. This overload only participates in overload resolution if std::is_constructible<T, std::initializer_list<U>&, Args&&...>::value is true.

### Parameters

args... | - | the arguments to pass to the constructor
ilist | - | the initializer list to pass to the constructor
Type requirements
- `T` must be constructible from `Args...`
- `T` must be constructible from std::initializer_list and `Args...`

### Return value

A reference to the new contained value.

### Exceptions

Any exception thrown by the selected constructor of `T`. If an exception is thrown, *this does not contain a value after this call (the previously contained value, if any, had been destroyed).

### See also

operator= | assigns contents (public member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/utility/optional/emplace&oldid=91290"